#include<iostream.h>
#include<fstream.h>
#include<math.h>
#define mapsize 128
float **heightmap;
//Random number generater. Not using rand this time....
float cosinterp(float a,float b,float x)
{
	float ft;
	float f;
	float ret;
	ft = x * 3.1415927;
	f = (1 - cos(ft)) * .5;
	ret=a*(1-f) + b*f;
	return ret;
}
float randnoise(int x,int y)
{
	int n=x+y*57;
	n=(n<<13)^n;
	float ret;
	ret=(1 - ( (n * (n * n * 15731 + 789221) + 1376312589) & 2147483647) / 1073741824.0);
	return ret;    
}
float smoothnoise(int x,int y)
{
	float corners=(randnoise(x-1,y-1)+randnoise(x+1,y-1)+randnoise(x-1,y+1)+randnoise(x+1,y+1))/16;
	float sides   = (randnoise(x-1, y)+randnoise(x+1, y)+randnoise(x, y-1)+randnoise(x, y+1) ) /  8;
	float center  =  randnoise(x, y) / 4;   
	float ret=corners+sides+center;
	return ret;
}
float interpnoise(float x, float y)
{
	int xi=x;
	float fractionx=x-xi;
	int yi=y;
	float fractiony=y-yi;
	float v1,v2,v3,v4,i1,i2;
	float ret;
	v1=smoothnoise(xi,     yi);
	v2=smoothnoise(xi + 1, yi);
	v3=smoothnoise(xi,     yi + 1);
	v4=smoothnoise(xi + 1, yi + 1);
	i1=cosinterp(v1,v2,fractionx);
	i2=cosinterp(v3,v4,fractionx);
	ret=cosinterp(i1,i2,fractiony);
	return ret;
}
float FBM(float x, float y, float octaves, float amplitude, float frequency, float h,float freqchange)
{
	float ret=0;
	
	for(int i=0;i<(octaves-1);i++)
	{
		ret +=( interpnoise (x* frequency, y* frequency)* amplitude);
		frequency*=freqchange;
		amplitude*=h;
		
	
	}
	return ret;	
}
float MultiFractal(float x, float y, float octaves, float amplitude, float frequency, float h,float offset,float freqchange)
{
	float ret=1;
	
	for(int i=0;i<(octaves-1);i++)
	{
		ret *=(offset+1)*( interpnoise (x* frequency, y* frequency)* amplitude);
		frequency*=freqchange;
		amplitude*=h;
		
	}
	return ret;
}
void dumplist(int x, int y,CString fn)
{
	fstream file;
	file.open(fn,ios::out,filebuf::sh_none);
	for(int a=0;a<y;a++)
	{
		for(int b=0;b<x;b++)
		{
			file<<(heightmap[a][b])<<" ";
		}
		file<<endl;
	}
}